﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Xps.Packaging;
using System.IO;
using System.ComponentModel;

namespace ThomasClaudiusHuber.PrintRangeExample
{
  /// <summary>
  /// Interaction logic for Window1.xaml
  /// </summary>
  public partial class MainWindow : Window
  {
    private FixedDocument _fixedDocument;

    public MainWindow()
    {
      InitializeComponent();
    }

    private void OnLoaded(object sender, RoutedEventArgs e)
    {
      // Load the FixedDocument
      var document = new XpsDocument("FivePagesDocument.xps",
                                      FileAccess.Read);
      var sequence = document.GetFixedDocumentSequence();
      _fixedDocument = sequence.References[0].GetDocument(false);

      // Assign it to the viewer
      viewer.Document = _fixedDocument.DocumentPaginator.Source;
    }

    void PrintButtonClick(object sender, RoutedEventArgs e)
    {
      var dlg = new PrintDialog();

      // Allow the user to select a PageRange
      dlg.UserPageRangeEnabled = true;

      if (dlg.ShowDialog() == true)
      {
        DocumentPaginator paginator =
          _fixedDocument.DocumentPaginator;

        if (dlg.PageRangeSelection == PageRangeSelection.UserPages)
        {
          paginator = new PageRangeDocumentPaginator(
                           _fixedDocument.DocumentPaginator,
                           dlg.PageRange);
        }
        dlg.PrintDocument(paginator, "Yes, it works");
      }
    }
  }
}
